dnl $Id: config.m4,v 1.3 2006/11/22 17:06:57 dsr Exp $
dnl config.m4 for extension sam

dnl Comments in this file start with the string 'dnl'.
dnl Remove where necessary. This file will not work
dnl without editing.

PHP_ARG_WITH(sam, for sam support,
 [  --with-sam             Include sam support])

if test "$PHP_SAM" != "no"; then

  dnl # --with-sam -> check with-path
  SEARCH_PATH="/opt"
  SEARCH_FOR="/IBM/XMS/tools/c/include/xms.h"  
  if test -r $PHP_SAM/; then # path given as parameter
    SAM_DIR=$PHP_SAM
  else # search default path list
    AC_MSG_CHECKING([for sam files in default path])
    for i in $SEARCH_PATH ; do
      if test -r $i/$SEARCH_FOR; then
        SAM_DIR=$i
        AC_MSG_RESULT(found in $i)
      fi
    done
  fi
  
  if test -z "$SAM_DIR"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Please reinstall the XMS distribution])
  fi

  dnl # --with-sam -> add include path
  PHP_ADD_INCLUDE($SAM_DIR/IBM/XMS/tools/c/include)

  dnl # --with-sam -> check for lib and symbol presence
  LIBNAME=gxi
  LIBSYMBOL=xmsConnFactCreate

  PHP_CHECK_LIBRARY($LIBNAME,$LIBSYMBOL,
   [
   PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $SAM_DIR/IBM/XMS/lib, SAM_SHARED_LIBADD)
   AC_DEFINE(HAVE_SAMLIB,1,[ ])
  ],[
   AC_MSG_ERROR([wrong sam lib version or lib not found])
  ],[
    -L$SAM_DIR/IBM/XMS/lib -lm -ldl
  ])
 
  PHP_SUBST(SAM_SHARED_LIBADD)

  PHP_NEW_EXTENSION(sam, php_sam.c SAM_Connection.c SAM_Message.c SAM_Utils.c, $ext_shared, , -DLINUX)
fi
